﻿Option Strict On
Imports Microsoft.Kinect
Imports Coding4Fun.Kinect.Wpf
Class MainWindow
    Dim kinect As KinectSensor


    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Try
            If KinectSensor.KinectSensors.Count = 0 Then
                MessageBox.Show("KINECTが接続されておりません。")
                Exit Sub
            Else
                kinect = KinectSensor.KinectSensors(0)
                kinect.DepthStream.Enable()
                kinect.DepthStream.Range = DepthRange.Near
                AddHandler kinect.DepthFrameReady, AddressOf kinect_DepthFrameReady
                kinect.Start()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Exit Sub
        End Try
    End Sub

    Private Sub kinect_DepthFrameReady(sender As Object, e As DepthImageFrameReadyEventArgs)
        Using depthImage As DepthImageFrame = e.OpenDepthImageFrame
            depthCamera.Source = depthImage.ToBitmapSource
        End Using
    End Sub

    Private Sub MainWindow_Closing(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles Me.Closing
        RemoveHandler kinect.DepthFrameReady, AddressOf kinect_DepthFrameReady
        If KinectSensor.KinectSensors(0).IsRunning = True Then
            KinectSensor.KinectSensors(0).Stop()
            KinectSensor.KinectSensors(0).Dispose()
        End If
    End Sub
End Class
